; Source created with Parsic Version 3.x

; at              : 17/08/02 14.02.11


; Project File    : c:\PROGRA~1\PARSIC\ADC\MWERT1.PIC

; Project Version : 1.0.22

; Created         : 23/06/02 20.56.00

; Last change     : 26/06/02 23.20.00

	PROCESSOR 16C711

	INCLUDE P16C711.INC

	RADIX DEC


	__IDLOCS H'0100'

	__CONFIG _CP_OFF & _PWRTE_ON & _WDT_OFF & _BODEN_ON & _XT_OSC

; Diverses

ZERO	EQU Z	; ZERO-Flag
CARRY	 EQU C	; CARRY-Flag


; Variable

ADC0	= 12	; located in Bank 0, 1
ADC0_HI	= 13	; located in Bank 0, 1
SYS_TMP1	= 14	; located in Bank 0, 1
S4	= 15	; located in Bank 0, 1
S4_HI	= 16	; located in Bank 0, 1
S0	= 17	; located in Bank 0, 1
S0_HI	= 18	; located in Bank 0, 1
SYS_TMP2	= 19	; located in Bank 0, 1
SYS_TMP3	= 20	; located in Bank 0, 1
SYS_TMP4	= 21	; located in Bank 0, 1
SYS_TMP5	= 22	; located in Bank 0, 1
SYS_TMP6	= 23	; located in Bank 0, 1
SYS_TMP7	= 24	; located in Bank 0, 1
S1	= 25	; located in Bank 0, 1
S1_HI	= 26	; located in Bank 0, 1
S2	= 27	; located in Bank 0, 1
S2_HI	= 28	; located in Bank 0, 1
MWERT	= 29	; located in Bank 0, 1
MWERT_HI	= 30	; located in Bank 0, 1
S3	= 31	; located in Bank 0, 1
S5	= 32	; located in Bank 0, 1
RAM	= 33	; located in Bank 0, 1

	ERRORLEVEL -302	; disable warning (Bankswitching)
	ERRORLEVEL -306	; disable warning (Pageswitching)

;****************************************
;Programmanfang
;****************************************

	ORG 0

	CLRF STATUS	; switch to RAM-Bank 0
	GOTO SYS_INIT
	NOP
	NOP
	RETURN

;****************************************
; Division 16 - Bit
; OP1 = SYS_TMP1,2
; OP2 = SYS_TMP3,4
;****************************************

SYSDIV16
	MOVFW SYS_TMP3	; Division durch 0 ?
	IORWF SYS_TMP4,W
	BTFSC STATUS,ZERO
	GOTO SYSDIV16_ERROR

	CLRF SYS_TMP5	; Ergebnis lschen
	CLRF SYS_TMP6
	MOVLW 1
	MOVWF SYS_TMP7
SYSDIV16_0
	BTFSC SYS_TMP4,7	; OP2 linksbndig
	GOTO SYSDIV16_1
	INCF SYS_TMP7,F
	BCF STATUS,CARRY
	RLF SYS_TMP3,F
	RLF SYS_TMP4,F
	GOTO SYSDIV16_0

SYSDIV16_1
	MOVFW SYS_TMP4	; OP1 und OP2 vergleichen
	SUBWF SYS_TMP2,W	; F-W -> W
	BTFSS STATUS,ZERO
	GOTO SYSDIV16_2
	MOVFW SYS_TMP3
	SUBWF SYS_TMP1,W	; F-W -> W

SYSDIV16_2
	BTFSS STATUS,CARRY
	GOTO SYSDIV16_3
	MOVFW SYS_TMP4	; OP1-OP2
	SUBWF SYS_TMP2,F	; F-W -> F
	MOVFW SYS_TMP3
	SUBWF SYS_TMP1,F	; F-W -> F
	BTFSS STATUS,CARRY
	DECF SYS_TMP2,F
	BSF STATUS,CARRY
SYSDIV16_3
	RLF SYS_TMP5,F	; Ergebnis aktualisieren
	RLF SYS_TMP6,F
	RRF SYS_TMP4,F	; OP2 nach rechts schieben
	RRF SYS_TMP3,F
	DECFSZ SYS_TMP7,F	; Zhler -1
	GOTO SYSDIV16_1

	RETURN

SYSDIV16_ERROR
	MOVLW 255
	MOVWF SYS_TMP5
	MOVWF SYS_TMP6
	RETURN


;****************************************
; Subroutines
;****************************************

;***************************************************
; Read  -> AN0
;***************************************************

READ_AN0
	BSF STATUS,RP0	; Bank 1
	BCF ADCON1,0
	BSF TRISA,0
	MOVLW B'11000001'	; CH0
	BCF STATUS,RP0	; Bank 0
	MOVWF ADCON0
	MOVLW 5
	MOVWF SYS_TMP1

SYS_ADC_LABEL_0
	DECFSZ SYS_TMP1,F
	GOTO SYS_ADC_LABEL_0

	BSF ADCON0,GO	; Wandlung starten

SYS_ADC_LABEL_1

	BTFSC ADCON0,GO	; Schon fertig ?
	GOTO SYS_ADC_LABEL_1	; Sprung, wenn nicht

	MOVFW ADRES	; Wert holen
	MOVWF ADC0	; und speichern

	MOVLW 3
	BSF STATUS,RP0	; Bank 1
	MOVWF ADCON1
	MOVLW B'11111111'
	MOVWF TRISA
	RETURN


;****************************************
;Initialisierung
;****************************************


SYS_INIT

	MOVLW B'00000000'
	MOVWF INTCON

; Ausgangs-Pegel setzen, bevor die Richtung gesetzt wird

	BCF STATUS,RP0	; Bank 0
	MOVLW B'00000000'
	MOVWF PORTA

	MOVLW B'00000000'
	MOVWF PORTB

	MOVLW 143
	BSF STATUS,RP0	; Bank 1
	MOVWF OPTION_REG

	MOVLW 3	; all digital
	MOVWF ADCON1

; Richtung setzen

	MOVLW B'11111111'
	MOVWF TRISA

	MOVLW B'11111111'
	MOVWF TRISB

; init vars


; Clear RAM

	MOVLW 12
	MOVWF FSR
CR1
	CLRF INDF
	INCF FSR,F
	MOVFW FSR
	SUBLW 80
	BTFSS STATUS,ZERO
	GOTO CR1

	MOVLW B'00000001'
	MOVWF S5


;**********************************
;******* Haupt-Programm ***********
;**********************************

MAIN

	CALL READ_AN0
;***************************************************
;AF1
;***************************************************

	MOVFW ADC0_HI
	ADDWF MWERT_HI,W
	MOVWF S4_HI
	MOVFW ADC0
	ADDWF MWERT,W
	MOVWF S4
	BTFSC STATUS,CARRY
	INCF S4_HI,F

LABEL_AF1_EXIT
;***************************************************
;AF2
;***************************************************

	MOVFW S4
	MOVWF SYS_TMP1
	MOVFW S4_HI
	MOVWF SYS_TMP2
	MOVLW LOW 2
	MOVWF SYS_TMP3
	MOVLW HIGH 2
	MOVWF SYS_TMP4
	CALL SYSDIV16
	MOVFW SYS_TMP5
	MOVWF S0
	MOVFW SYS_TMP6
	MOVWF S0_HI

LABEL_AF2_EXIT
;***************************************************
;AF3
;***************************************************

	MOVFW S0_HI
	ADDWF MWERT_HI,W
	MOVWF S1_HI
	MOVFW S0
	ADDWF MWERT,W
	MOVWF S1
	BTFSC STATUS,CARRY
	INCF S1_HI,F

LABEL_AF3_EXIT
;***************************************************
;AF4
;***************************************************

	MOVFW S1
	MOVWF SYS_TMP1
	MOVFW S1_HI
	MOVWF SYS_TMP2
	MOVLW LOW 2
	MOVWF SYS_TMP3
	MOVLW HIGH 2
	MOVWF SYS_TMP4
	CALL SYSDIV16
	MOVFW SYS_TMP5
	MOVWF S2
	MOVFW SYS_TMP6
	MOVWF S2_HI

LABEL_AF4_EXIT
;***************************************************
; Multiplexer -> MX1
;***************************************************

	CLRF SYS_TMP1
	MOVFW S3
	BTFSS STATUS,ZERO
	GOTO LABEL_MX1_CHECKCONTROL1

	MOVFW MWERT
	MOVWF MWERT
	MOVFW MWERT_HI
	MOVWF MWERT_HI
	GOTO LABEL_MX1_END

LABEL_MX1_CHECKCONTROL1
	INCF SYS_TMP1,F
	MOVFW S3
	SUBWF SYS_TMP1,W
	BTFSS STATUS,ZERO
	GOTO LABEL_MX1_CHECKCONTROL2

	MOVFW S2
	MOVWF MWERT
	MOVFW S2_HI
	MOVWF MWERT_HI
	GOTO LABEL_MX1_END

LABEL_MX1_CHECKCONTROL2

LABEL_MX1_END

;***************************************************
; Verteiler -> BV1
;***************************************************

	MOVLW 0 
	BTFSC S5,0	; IN0
	IORLW 1
	MOVWF S3	; OUT

;***************************************************
; UND - Gatter -> LG1
;***************************************************

LABEL_LG1_1
	BTFSS S5,0
	GOTO LABEL_LG1_FALSE

LABEL_LG1_TRUE
	BCF S5,0
	GOTO LABEL_LG1_ENDE
LABEL_LG1_FALSE
	BSF S5,0
LABEL_LG1_ENDE
;****************************************

	GOTO MAIN


	END

